define( ["/javascript/moment.js"], function(  ) {
"use strict";


function FromToDateValidation()
{
};

FromToDateValidation.prototype.initialize = function( oControlHost, fnDoneInitializing )
{
  var o = oControlHost.configuration
    , moment=require('/javascript/moment.js')
    , secondaryRun
    , dynStartDate
    , dynEndDate
    , datastores;
    
  this.ctrlFrom = o ? o["fromPrompt"] : 'fromDate';
  this.ctrlTo =   o ? o["toPrompt"] : 'toDate';
  secondaryRun = sessionStorage.getItem(this.ctrlFrom+'secondaryRun');

    //optional dynDate from configuration
    if(!secondaryRun&&o&&o["dynStartDate"]&&moment(eval(o["dynStartDate"])).isValid()) {
      dynStartDate=moment(eval(o["dynStartDate"])).format('YYYY-MM-DD');
    };

    //optional dynDate from configuration
    if(!secondaryRun&&o&&o["dynEndDate"]&&moment(eval(o["dynEndDate"])).isValid()) {
      dynEndDate=moment(eval(o["dynEndDate"])).format('YYYY-MM-DD');
    };
    //check for datasets
    if(oControlHost.control.dataStores) datastores = oControlHost.control.dataStores;

    if(datastores&&datastores.length>0){
      //if datastores have been found, let's start looking for minDate. First we loop through the datastores
      for(var i=0;i<datastores.length;++i){
        //then we loop through the columns
        for(var j=0;j<datastores[i].columnNames.length;++j){
          //test for dynDate
          if(datastores[i].columnNames[j]=='dynStartDate') dynStartDate = datastores[i].columnValues[j][0].substring(0,10);
          if(datastores[i].columnNames[j]=='dynEndDate') dynEndDate = datastores[i].columnValues[j][0].substring(0,10);
        }
      }
      
    };

  if(!secondaryRun&&dynStartDate) oControlHost.page.getControlByName(this.ctrlFrom).setValues([{'use':dynStartDate}]);
  if(!secondaryRun&&dynEndDate)   oControlHost.page.getControlByName(this.ctrlTo).setValues([{'use':dynEndDate}]);
  
  sessionStorage.setItem(this.ctrlFrom+'secondaryRun',1);
  
 var fromVal = function(values){
    var o = oControlHost.configuration
      , ctrlFrom = o ? o["fromPrompt"] : 'fromDate'
      , ctrlTo =   o ? o["toPrompt"] : 'toDate'
      , ctrl = oControlHost.page.getControlByName(ctrlFrom)
      , fromDt = moment(values[0].use).toDate()
      , toDt =   moment(oControlHost.page.getControlByName(ctrlTo).getValues()[0].use).toDate()
      , datastores =[]
      , minDate;

      
    
    //basic check to ensure the from date is before than the to date.
    if(fromDt > toDt ) {
      ctrl.setValidator(function(){});
      ctrl.setValues(oControlHost.page.getControlByName(ctrlTo).getValues());
      ctrl.setValidator(fromVal);          
      return true;
      };    
         
    //optional minDate from configuration
    if(o&&o["minDate"]&&moment(eval(o["minDate"])).isValid()&&fromDt < moment(eval(o["minDate"])).toDate()) {
      ctrl.setValidator(function(){});
      ctrl.setValues([{'use':moment(eval(o["minDate"])).format('YYYY-MM-DD')}]);
      ctrl.setValidator(fromVal);          
      return true;
    };
      

   //check for datasets
    if(oControlHost.control.dataStores) {
    datastores = oControlHost.control.dataStores;


      if(datastores&&datastores.length>0){
        //if datastores have been found, let's start looking for minDate. First we loop through the datastores
        for(var i=0;i<datastores.length;++i){
          //then we loop through the columns
          for(var j=0;j<datastores[i].columnNames.length;++j){
            //test each column for minDate, and if we find it populate minDate
            if(datastores[i].columnNames[j]=='minDate') {
              minDate = datastores[i].columnValues[j][0].substring(0,10);
              if(fromDt < moment(minDate).toDate()) {
                ctrl.setValidator(function(){});
                ctrl.setValues([{'use':minDate}]);
                ctrl.setValidator(fromVal);          
              }
            }
          }
        }
      }
    };
            
    return true;
  }
  
  oControlHost.page.getControlByName(this.ctrlFrom).setValidator(fromVal);
     
     

 var toVal = function(values){
  var o = oControlHost.configuration
    , ctrlFrom = o ? o["fromPrompt"] : 'fromDate'
    , ctrlTo =   o ? o["toPrompt"] : 'toDate'
    , ctrl = oControlHost.page.getControlByName(ctrlTo)
    , fromDt = oControlHost.page.getControlByName(ctrlFrom).getValues()[0].use
    , toDt =   values[0].use
    , datastores =[]
    , maxDate;

    //basic check to ensure the from date is before than the to date.
    if(fromDt > toDt ) {
      var dt = oControlHost.page.getControlByName(ctrlFrom).getValues()[0].use;
      ctrl.setValidator(function(){});
      ctrl.setValues([{'use':dt}]);
      ctrl.setValidator(toVal);
      return true;
      };
      
        
    //optional maxDate from configuration
    if(o&&o["maxDate"]&&moment(eval(o["maxDate"])).isValid()&&toDt > moment(eval(o["maxDate"])).format("YYYY-MM-DD")) {
      var dt = moment(eval(o["maxDate"])).format('YYYY-MM-DD');
      ctrl.setValidator(function(){});
      ctrl.setValues([{'use':dt}]);
      ctrl.setValidator(toVal);
      return true;
      };
    
    //check for datasets. 
    if(oControlHost.control.dataStores) {
    datastores = oControlHost.control.dataStores;

      if(datastores&&datastores.length>0){
        //if datastores have been found, let's start looking for minDate. First we loop through the datastores
        for(var i=0;i<datastores.length;++i){
          //then we loop through the columns
          for(var j=0;j<datastores[i].columnNames.length;++j){
            //test each column for maxDate, and if we find it, test if the date exceeds
            if(datastores[i].columnNames[j]=='maxDate') {
              maxDate = datastores[i].columnValues[j][0].substring(0,10);
              if(toDt > maxDate) {
                ctrl.setValidator(function(){});
                ctrl.setValues([{'use':maxDate}]);
                ctrl.setValidator(toVal);
              }
            }
          }
        }
      }
    };
    return true;
  };
  
  oControlHost.page.getControlByName(this.ctrlTo).setValidator(toVal);
   



fnDoneInitializing();
	
};

return FromToDateValidation;
});